#{extends 'border.html'/}
<div class="container-fluid">
    <div class="alert-container"></div>
	<div class="row">
		<div class="col-md-12">
			<!-- Breadcrumb -->
			<ol class="breadcrumb">
				<li><a href="@{PublikCtr.home()}">&{'beranda.label'}</a></li>
				<li><a href="@{admin.KomoditasCtr.index()}">&{'komoditas.label'}</a></li>
				<li><a href="#">&{'usulan.label'}</a></li>
				<li class="active">&{'ubah.label'} &{'jadwal.label'}</li>
			</ol>
			<!-- End Breadcrumb -->
		</div>
	</div>
	#{alert /}
	#{form @admin.UsulanCtr.editAllJadwalSubmit(), method:'POST', id:'form-all-jadwal' }
	<div class="row">
		<div class="col-md-12">
			<!-- Toolbar -->
			<div class="toolbar">
                #{backButton action:@admin.UsulanCtr.detail(usulan.id)/}
                <button class="btn btn-md btn-primary"><i class="fa fa-save"></i> &{'simpan.label'}</button>
			</div>
			<!-- End Toolbar -->
		</div>
	</div>

    <input type="hidden" name="form.usulan_id" value="${usulan.id}"/>

	<div class="row">

		<div class="col-md-12">
			<div class="panel panel-default">
				<div class="panel-heading">
					<h5>&{'ubah.label'} &{'jadwal.label'} - ${usulan.nama_usulan}</h5>
				</div>
                <div class="panel-body" style="overflow-x: auto">
                    <table class="table table-condensed table-striped">
                        <thead>
                        <tr>
                            <th style="width: 40%">&{'tahapan.label'}</th>
                            <th style="width: 25%">&{'tanggal.label'}</th>
                            <th>&{'keterangan.label'}</th>
                        </tr>
                        </thead>
                        <tbody>
                            #{list listJadwal, as:'jadwal'}
                                <input type="hidden" name="form.jadwalUsulanList[${jadwal_index-1}].id" value="${jadwal.id}"/>
                                <input type="hidden" name="form.jadwalUsulanList[${jadwal_index-1}].tahapan_id" value="${jadwal.tahapan_id}"/>
                                <input type="hidden" name="form.jadwalUsulanList[${jadwal_index-1}].nama_tahapan" value="${jadwal.nama_tahapan}"/>
                                <tr>
                                    <td class="title">${jadwal.nama_tahapan}</td>
                                    <td>
                                        <div class="input-group input-daterange range-container" name="form.jadwalUsulanList[${jadwal_index-1}]">
                                            <input class="form-control datepicker" required name="form.jadwalUsulanList[${jadwal_index-1}].tanggal_mulai"
                                                   type="text" value='${utils.DateTimeUtils.formatDateToString(jadwal.tanggal_mulai,"dd-MM-yyyy")}'  />
                                            <div class="input-group-addon">&{"sampai_dengan.label"}</div>
                                            <input class="form-control datepicker finish-date" required name="form.jadwalUsulanList[${jadwal_index-1}].tanggal_selesai"
                                                   type="text"  value='${utils.DateTimeUtils.formatDateToString(jadwal.tanggal_selesai,"dd-MM-yyyy")}'/>
                                        </div>
                                    </td>
                                    <td>
                                        <textarea name="form.jadwalUsulanList[${jadwal_index-1}].keterangan" placeholder="&{'usulan.jadwal.keterangan.info'}" class="form-control"></textarea>
                                    </td>
                                </tr>
                            #{/list}
                        </tbody>
                    </table>
				</div>
			</div>
		</div>
	</div>
	#{/form}
</div>
#{validationPackage/}
#{set 'moreScripts'}
<script type="text/javascript">
    var arrRowData = [];
    $(document).ready(function() {
        $('#form-all-jadwal').validate();
        $('.datepicker').datepicker()
        .on("changeDate", function(e) {
            var name = $(this).attr("name");
            //changeDate(name, e.date);
            newRulesDate(name, e.date);
            validateKeterangan(name);
        });

        $('#form-all-jadwal').submit(function(){
            return validateDate();
        });
        
        $('.range-container').each(function(idx, field){
            var data = 
            {
                name : $(field).attr("name"),
                tanggal_mulai : $(field).find('[name*=tanggal_mulai]').val(),
                tanggal_selesai : $(field).find('[name*=tanggal_selesai]').val()
            };
            arrRowData.push(data);
        });

    });

    var newRulesDate = function (name, date) {
        var arrName = name.split('.');
        if(arrName[2] == "tanggal_mulai"){
            var nextDay = new Date(date);
            nextDay.setDate(nextDay.getDate() + 1);
            arrName.pop();
            arrName.push("tanggal_selesai");
            $('.finish-date[name="' + arrName.join(".") + '"]').data("datepicker").setStartDate(nextDay);
        }
    };

    var changeDate = function(name, date){
        var arrName = name.split('.');
        if(arrName[2] == "tanggal_mulai"){
            arrName.pop();
            arrName.push("tanggal_selesai");
            $('.finish-date[name="' + arrName.join(".") + '"]').data("datepicker").setStartDate(date);
            changeDate(arrName.join("."), date);
        }else{
            var arrNF = ["form"];
            var i = arrName[1].replace(arrName[1].match(/\d+/)[0],parseInt(arrName[1].match(/\d+/)[0]) + 1);
            arrNF.push(i);
            arrNF.push("tanggal_mulai");
            if($('.datepicker[name="' + arrNF.join(".") + '"]').length > 0){
                $('.datepicker[name="' + arrNF.join(".") + '"]').data("datepicker").setStartDate(date);
                changeDate(arrNF.join("."), date);
            }
        }
    }

    var validateKeterangan = function(name){
        var arrName = name.split('.');
        var nField = arrName.pop();
        var theName = arrName.join(".");
        var data = arrRowData.find(function(field){
            return field.name == theName;
        });
        var valMulai = $('[name="' + theName +'.tanggal_mulai"]').val();
        var valSelesai = $('[name="' + theName +'.tanggal_selesai"]').val();
        if(data.tanggal_mulai != valMulai || data.tanggal_selesai != valSelesai){
            $('[name="' + theName +'.keterangan"]').attr('required',true);
        }else{
            $('[name="' + theName +'.keterangan"]').removeAttr('required');
        }
    }

    function validateDate() {
        var array = [];
        jQuery('.range-container').each(function () {
            var view = jQuery(this);
            var finish = view.find('.finish-date');
            var date = finish.datepicker('getDate');
            array.push(date.toISOString());
        });
        var first = array[0];
        var totalInvalid = 0;
        for (var i = 0; i < array.length; i++) {
            if (array[i] >= first) {
                first = array[i];
            } else {
                totalInvalid++;
            }
        }
        totalInvalid = 0;
        var status = totalInvalid > 0;
        showMessage("Tanggal selesai setiap tahapan tidak bisa lebih kecil dari tanggal selesai tahapan sebelumnya!", status);
        return !status && $('[name*=".keterangan"]').valid();
    }

    function showMessage(message, show) {
        var container = jQuery('.alert-container');
        if (show) {
            container.html('<div class="alert alert-danger">'+message+'</div>');
        } else {
            container.html('');
        }
    }
</script>
#{/set}